/*

 LLiFix v0.1 (c) tr/uCF (tr@ucf2000.com)

 This program fixes the calls to the import table  
 that was redirected to LaserLock's Delta.dll (32Bit)
 It will attempt to gather all infos itself depending on 
 a known structure version of DELTA.DLL's info block.
 
 After looking more...the INFOBLOCK is'nt always the same!
 You can easily check new block format and recompile again.

 To find info block in .DLL,try searching for DLL's name in .DLL file.
 Example: if it's mydll.dll try to search in 'mydll.dll' for string 'mydll.dll'
 Once found you will see something like the following structure.
 General Structure layout:

  char           dll_name[50];
  char           exe_name[50];
  DWORD          def_imagebase;
  DWORD          _u1[2];
  DWORD          k1;
  DWORD          code_rva;
  DWORD          code_vsize;
  DWORD          _u2[3];
  DWORD          k2;
  DWORD          _u3[6];
  DWORD          refcount;
  char           *addr_tbl0;

  Read source file to know how to get use of this infoblock.
*/

/*
 Here are some variant INFOBLOCK defenitions.
 Notice that each structure differs a little

// 4.03
typedef struct
 {
  char           dll_name[50];
  char           exe_name[50];
  DWORD          def_imagebase;
  DWORD          _u1[2];
  DWORD          k1;
  DWORD          code_rva;
  DWORD          code_vsize;
  DWORD          _u2[3];
  DWORD          k2;
  DWORD          code_seek;
  DWORD          code_rva2;
  DWORD          _u3[4];
  DWORD          refcount;
  char           *addr_tbl0;
 } LL_INFOBLOCK;

// 4.03
typedef struct
 {
  char           dll_name[50];
  char           exe_name[50];
  DWORD          def_imagebase;
  DWORD          _u1[2];
  DWORD          k1;
  DWORD          code_rva;
  DWORD          code_vsize;
  DWORD          _u2[2];
  DWORD          k2;
  DWORD          code_seek;
  DWORD          code_rva2;
  DWORD          _u3[4];
  DWORD          refcount;
  char           *addr_tbl0;
 } LL_INFOBLOCK;


// 4.05.02
typedef struct
 {
  char           dll_name[50];
  char           exe_name[50];
  DWORD          def_imagebase;
  DWORD          _u1[2];
  DWORD          k1;
  DWORD          code_seek;
  DWORD          code_vsize;
  DWORD          _u2[3];
  DWORD          k2;
  DWORD          _u4;
  DWORD          code_rva;
  DWORD          _u3[4];
  DWORD          refcount;
  char           *addr_tbl0;
 } LL_INFOBLOCK;

// 4.05.02
typedef struct
 {
  char           dll_name[50];
  char           exe_name[50];
  DWORD          def_imagebase;
  DWORD          _u1[2];
  DWORD          k1;
  DWORD          code_rva;
  DWORD          code_vsize;
  DWORD          _u2[3];
  DWORD          k2;
  DWORD          code_seek;
  DWORD          code_rva2;
  DWORD          _u3[4];
  DWORD          refcount;
  char           *addr_tbl0;
 } LL_INFOBLOCK;

*/
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define LLIFIXVER "0.1 Build 1 for LaserLok 4.05.02"

#pragma pack(4)
typedef struct
 {
  char           dll_name[50];
  char           exe_name[50];
  DWORD          def_imagebase;
  DWORD          _u1[2];
  DWORD          k1;
  DWORD          code_rva;
  DWORD          code_vsize;
  DWORD          _u2[3];
  DWORD          k2;
  DWORD          code_seek;
  DWORD          code_rva2;
  DWORD          _u3[4];
  DWORD          refcount;
  char           *addr_tbl0;
 } LL_INFOBLOCK;
#pragma pack()


DWORD readfile(char *fn,char **mem)
{
  FILE *fp;
  DWORD fSize;
  
  fp = fopen(fn,"rb");
  if (fp==NULL) goto r0;
  fseek(fp,0,SEEK_END);
  fSize = ftell(fp);
  fseek(fp,0,SEEK_SET);
  *mem = (char *) malloc(fSize);
  if (*mem==NULL) goto r0;
  fread(*mem,fSize,1,fp);
  fclose(fp);
  
  return fSize;
  r0:
  return 0;
}

void writefile(char *fn,char *mem,DWORD size)
{
  FILE *fp;
  
  fp = fopen(fn,"wb");
  fwrite(mem,size,1,fp);
  fclose(fp);
}

void about(void)
{
  printf("\nLaserLock Import Fixer (LLiFix) v%s (c) tr/uCF2000\n\n",LLIFIXVER);  
}

char *buf_buf_strlwr(char *b1,char *b2,DWORD sz1,DWORD sz2)
{
 char *p1,*p2;
 DWORD x,y;
 char c;
 p1 = b1;
 p2 = b2;

 
 for (y=0;y<sz1;y++)
  {
    c = tolower(*p1);
    if ( c!=*p2 ) p1++;
	 else
	  {
		x = sz2;
		c = tolower(*p1);
		while (c==*p2) 
		  { 
		    x--;
			p1++;
			p2++;
			c = tolower(*p1);
            if (!x) return p1-sz2;
		  }
		p2 = b2;
		x  = sz2;
	  }
  }
 return NULL;
}

int main(int argc,char *argv[])
{
 LL_INFOBLOCK *llib;

 char *dll_mem,*exe_mem;
 char dll_fn[50],exe_fn[50];
 DWORD dll_size,file_size;

 char *tbl0,*tbl1,*tbl2,*codeptr,*p1;
 char flag;

 DWORD i,ref,idata;
 PDWORD oldidata;
 BOOL debug = FALSE;

 about();                                         // Display About

 if (argc<2)                                      // Check command line
  {                                               
	printf("[?] syntax: LLiFix DELTA.DLL [FILE.EXE] [-d]\n");
	exit(1);
  }

 // Check for debug flag
 if (argc>3)
  if (tolower(argv[3][1])=='d') 
          debug = TRUE;


 strcpy(dll_fn,strlwr(argv[1]));                 // Take a copy of DLL name

 dll_size  = readfile(dll_fn,&dll_mem);          // Read DLL file name

 if (dll_size==0)                                // No mem? DLL not there?
  {
    printf(" [!] Not enough memory or %s does not exist!\n",dll_fn);
	exit(1);
  }

 printf(" [*] '%s' (%ld) opened successfully.\n",dll_fn,dll_size); 

 p1 = buf_buf_strlwr(dll_mem,dll_fn,dll_size,strlen(dll_fn));       // Search in DLL for LL_INFOBLOCK

 if (p1==NULL)
  {
    printf(" [!] DLL name does not match! Cannot find INFOBLOCK!\n");
    exit(1);
  }

 llib = (LL_INFOBLOCK *)p1;                      // Point to that INFOBLOCK

 strcpy(exe_fn,llib->exe_name);
 if (argc>=3)
  {
   printf(" [*] Assuming user defined '%s' is the exe file.\n",argv[2]);
   strcpy(exe_fn,argv[2]);
  } else
  {
   printf(" [*] Assuming internal '%s' is the exe file.\n",llib->exe_name);
  }

 file_size = readfile(exe_fn,&exe_mem);

 if (file_size==0)
  {
    printf(" [!] No mem Or '%s' does not exist!\n",exe_fn);
	exit(1);
  }

 printf(" [*] CallDLL reference count is %ld\n",llib->refcount);
 printf(" [*] Default EXE's image base is %08lX\n",llib->def_imagebase);
 printf(" [*] Original 'IDATA references info' decryption key is %08lX\n",llib->k1);
 printf(" [*] Target's CODE_SEEK=%08lX and CODE_VSIZE=%08lX\n",llib->code_seek,llib->code_vsize);
 printf(" [*] IDATA reference infos are at offest %08lX and sized of %ld byte(s)\n",(DWORD)((char *)&llib->addr_tbl0-dll_mem),(DWORD)llib->refcount*9);

 tbl0 = (char *)(char *)&llib->addr_tbl0;
 tbl1 = tbl0+4;
 tbl2 = tbl0+8;

 codeptr = exe_mem + llib->code_seek;

 for (i=0;i<llib->refcount;i++)
  {
    ref      = *(DWORD *)(tbl0 + i*9) - llib->code_rva;
    idata    = *(DWORD *)(tbl1 + i*9) ^ llib->k1;
    flag     = *(tbl2 + i*9);
    oldidata = (DWORD *)(codeptr+ref-4);

    *oldidata = idata + llib->def_imagebase;
    if (flag==1)
                 *(char *)((char *)oldidata-1) = 0x25;
	if (debug)
      printf(" [?] Idx = %lX Flag:%d Refeerer:%lX to IDATA at: %lX\n",i,flag,ref,idata);
  }
 
 writefile("out.exe",exe_mem,file_size);
 printf(" [*] Written to: out.exe");
 free(dll_mem);
 free(exe_mem);
 return 0;
}

/*
 tr/uCF2000 / tr@ucf2000.com
*/